<?php
/*
 * @component jOpenSim
 * @copyright Copyright (C) 2019 FoTo50 http://www.jopensim.com/
 * @license GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */
defined('_JEXEC') or die();

require_once(JPATH_COMPONENT_SITE.DIRECTORY_SEPARATOR.'models'.DIRECTORY_SEPARATOR.'opensim.php');

if(!function_exists("mysqlsafestring")) {
	function mysqlsafestring($string) {
		$db = JFactory::getDBO();
		return $db->escape($string);
	}
}

class opensimModelInterface extends OpenSimModelOpenSim {

	public $settings;
	public $filename = "interface.php";
	public $view = "interface";
	public $_os_db;
	public $_osgrid_db;
	public $_db;
	public $xmlrpcfunctions = array();
	public $debug;

	public $groupWriteKey;
	public $groupReadKey;


	public function __construct() {
		parent::__construct();
		$this->settings = $this->getSettingsData();
		$this->initMethods();
		$this->setDebug();
	}

// #######################################
// ########## profile functions ##########
// #######################################

	public function avatar_properties_request($parameter) {
//		error_log("here I am ;) (Zeile ".__LINE__.")");
		$this->simpledebugzeile(__FUNCTION__.": ".var_export($parameter,TRUE),"profile");
//		error_log("here I am ;) (Zeile ".__LINE__.")");
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") {
//			simpledebugzeile(__FUNCTION__.": ".varexport($parameter,TRUE));
//		}
		if(!array_key_exists("avatar_id",$parameter)) {
			$retval['success'] = FALSE;
			$retval['errorMessage']	= "No avatar_id specified";
			return $retval;
		}
		$avatar_id = $parameter['avatar_id'];
		$query = sprintf("SELECT
							partner 		AS Partner,
							url				AS ProfileUrl,
							wantmask		AS wantmask,
							wanttext		AS wanttext,
							skillsmask		AS skillsmask,
							skillstext		AS skillstext,
							languages		AS languages,
							firstLifeImage	AS FirstLifeImage,
							firstLifeText	AS FirstLifeAboutText,
							image			AS Image,
							aboutText		AS AboutText,
							allowPublish	AS userFlags
						FROM
							#__opensim_userprofile
						WHERE
							avatar_id = '%s'",
					$avatar_id);
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$profile = $db->loadAssocList();
		$retval['success'] = TRUE;
		if(count($profile) == 1) {
			// decode first all during storing encoded fields
			$retval['data'][0]['Partner']				= $profile[0]['Partner'];
			$retval['data'][0]['ProfileUrl']			= utf8_decode($profile[0]['ProfileUrl']);
			$retval['data'][0]['wantmask']				= $profile[0]['wantmask'];
			$retval['data'][0]['wanttext']				= utf8_decode($profile[0]['wanttext']);
			$retval['data'][0]['skillsmask']			= $profile[0]['skillsmask'];
			$retval['data'][0]['skillstext']			= utf8_decode($profile[0]['skillstext']);
			$retval['data'][0]['languages']				= utf8_decode($profile[0]['languages']);
			$retval['data'][0]['FirstLifeImage']		= $profile[0]['FirstLifeImage'];
			$retval['data'][0]['FirstLifeAboutText']	= utf8_decode($profile[0]['FirstLifeAboutText']);
			$retval['data'][0]['Image']					= $profile[0]['Image'];
			$retval['data'][0]['AboutText']				= utf8_decode($profile[0]['AboutText']);
			$retval['data'][0]['userFlags']				= $profile[0]['userFlags'];
		} else {
			$retval['data'][0]['Partner']				= null;
			$retval['data'][0]['ProfileUrl']			= null;
			$retval['data'][0]['wantmask']				= 0;
			$retval['data'][0]['wanttext']				= "";
			$retval['data'][0]['skillsmask']			= 0;
			$retval['data'][0]['skillstext']			= "";
			$retval['data'][0]['languages']				= "";
			$retval['data'][0]['FirstLifeImage']		= null;
			$retval['data'][0]['FirstLifeAboutText']	= "";
			$retval['data'][0]['Image']					= null;
			$retval['data'][0]['AboutText'] 			= JText::_('NOPROFILEAVAILABLE');
			$retval['data'][0]['userFlags']				= 0;
		}
		return $retval;
	}

	public function user_preferences_request($parameter) {
//		global $opensim,$debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") {
//			simpledebugzeile(__FUNCION__.": ".varexport($parameter,TRUE));
//		}
		$uuid 		= $parameter['avatar_id'];
		$query = sprintf("SELECT im2email, visible FROM #__opensim_usersettings WHERE uuid = '%s'",$uuid);
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$db->execute();
		$num_rows = $db->getNumRows();
		if($num_rows == 0) {
			$query = sprintf("INSERT INTO #__opensim_usersettings (uuid,im2email,visible) VALUES ('%s',0,0)",$uuid);
			$db->setQuery($query);
			$db->execute();
		} else {
			$usersettings = $db->loadAssoc();
		}
		$user['imviaemail'] = (isset($usersettings['im2email']) && $usersettings['im2email'] == 1) ? "true":"false";
		$user['visible'] = (isset($usersettings['visible']) && $usersettings['visible'] == 1) ? "true":"false";

		$usersettings2 = $this->opensim->getUserData($uuid);

		$data[] = array('imviaemail' => $user['imviaemail'],
						'visible' 	 => $user['visible'],
						'email' 	 => $usersettings2['email'],
						'userFlags'	 => 65535);

		$retval['success'] = TRUE;
		$retval['errorMessage']	= "";
		$retval['data'] = $data;
		return $retval;
	}

	public function user_preferences_update($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$uuid = $parameter['avatar_id'];
		$im2email = (strtolower($parameter['imViaEmail']) == "true") ? "1":"0";
		$visible = (strtolower($parameter['visible']) == "true") ? "1":"0";
		$query = sprintf("UPDATE #__opensim_usersettings SET im2email = '%d', visible = '%d' WHERE uuid = '%s'",$im2email,$visible,$uuid);
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$db->execute();
		$retval['success'] = TRUE;
		$retval['errorMessage']	= "";
		return $retval;
	}

	public function avatar_properties_update($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$query = sprintf("INSERT INTO #__opensim_userprofile
								(avatar_id,aboutText,allowPublish,firstLifeImage,image,url,firstLifeText)
							VALUES
								('%1\$s','%2\$s','%3\$s','%4\$s','%5\$s','%6\$s','%7\$s')
							ON DUPLICATE KEY UPDATE
								aboutText = '%2\$s',
								allowPublish = '%3\$s',
								firstLifeImage = '%4\$s',
								image = '%5\$s',
								url = '%6\$s',
								firstLifeText = '%7\$s'",
					mysqlsafestring($parameter['avatar_id']),
					mysqlsafestring(utf8_encode($parameter['AboutText'])),
					mysqlsafestring(utf8_encode($parameter['userFlags'])),
					mysqlsafestring($parameter['FirstLifeImage']),
					mysqlsafestring($parameter['Image']),
					mysqlsafestring(utf8_encode($parameter['ProfileUrl'])),
					mysqlsafestring(utf8_encode($parameter['FirstLifeAboutText'])));
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$result = $db->execute();
		if($result) {
			$retval['success']		= TRUE;
			$retval['errorMessage']	= "";
		} else {
			$retval['success']		= FALSE;
			$retval['errorMessage']	= JText::_('ERROR_UPDATEPROFILE');
		}
		return $retval;
	}

	public function avatar_interests_update($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$db = JFactory::getDBO();
		$query = sprintf("INSERT INTO #__opensim_userprofile
									(avatar_id,skillstext,languages,wantmask,skillsmask,wanttext)
								VALUES
									('%1\$s','%2\$s','%3\$s','%4\$s','%5\$s','%6\$s')
								ON DUPLICATE KEY UPDATE
									skillstext	= '%2\$s',
									languages	= '%3\$s',
									wantmask	= '%4\$s',
									skillsmask	= '%5\$s',
									wanttext	= '%6\$s'",
						mysqlsafestring($parameter['avatar_id']),
						mysqlsafestring(utf8_encode($parameter['skillstext'])),
						mysqlsafestring(utf8_encode($parameter['languages'])),
						mysqlsafestring($parameter['wantmask']),
						mysqlsafestring($parameter['skillsmask']),
						mysqlsafestring(utf8_encode($parameter['wanttext'])));
		$db->setQuery($query);
		$result = $db->execute();
		if($result) {
			$retval['success']		= TRUE;
			$retval['errorMessage']	= "";
		} else {
			$retval['success']		= FALSE;
			$retval['errorMessage']	= JText::_('ERROR_UPDATEPROFILE');
		}
		return $retval;
	}

	public function avatarnotesrequest($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$avatar_id = $parameter['avatar_id'];
		$target_uid = $parameter['uuid'];
		$query = sprintf("SELECT * FROM #__opensim_usernotes WHERE avatar_id = '%s' AND target_id = '%s'",
							mysqlsafestring($avatar_id),
							mysqlsafestring($target_uid));
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$notes = $db->loadAssocList();
		if(count($notes) == 0) {
			$retval['data'][0]['notes'] = null;
		} else {
			$retval['data'][0]['notes'] 	= utf8_decode($notes[0]['notes']);
		}
		$retval['data'][0]['targetid']	= $target_uid;
		$retval['success'] = TRUE;
		$retval['errorMessage'] = '';
	//	debugzeile("\avatarnotesrequest return -> ".varexport($retval,TRUE));
		return $retval;
	}

	public function avatar_notes_update($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$avatar_id	= $parameter['avatar_id'];
		$target_uid	= $parameter['target_id'];
		$notes	= utf8_encode($parameter['notes']);
		$db		= JFactory::getDBO();
		$query	= sprintf("INSERT INTO #__opensim_usernotes (avatar_id,target_id,notes) VALUES ('%1\$s','%2\$s','%3\$s')
									ON DUPLICATE KEY UPDATE notes = '%3\$s'",
							mysqlsafestring($avatar_id),
							mysqlsafestring($target_uid),
							mysqlsafestring($notes));
		$db->setQuery($query);
		$result = $db->execute();
		if($result) {
			$retval['success']		= TRUE;
			$retval['errorMessage']	= "";
		} else {
			$retval['success']		= FALSE;
			$retval['errorMessage']	= JText::_('ERROR_UPDATENOTES');
		}
		return $retval;
	}

	public function avatarpicksrequest($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") {
//			simpledebugzeile(__FUNCTION__.": ".varexport($parameter,TRUE));
//		}
		$db		= JFactory::getDBO();
		$query	= sprintf("SELECT * FROM #__opensim_userpicks WHERE creatoruuid = '%s'",mysqlsafestring($parameter['uuid']));
		$db->setQuery($query);
		$picks	= $db->loadAssocList();
		$data	= array();
		foreach($picks AS $pick) {
			$name = $pick['name'];
			$data[] = array('pickid' => $pick['pickuuid'],
							'name' 	 => $name );
		}
		$retval = array('success'		=> True,
						'errorMessage'	=> '',
						'data'			=> $data);
		return $retval;
	}

	public function pickinforequest($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$db		= JFactory::getDBO();
		$query	= sprintf("SELECT * FROM #__opensim_userpicks WHERE creatoruuid = '%s' AND pickuuid = '%s'",
								mysqlsafestring($parameter['avatar_id']),
								mysqlsafestring($parameter['pick_id']));
		$db->setQuery($query);
		$pick = $db->loadAssocList();
		$returnpick = $pick[0];
		$returnpick['description'] = $returnpick['description'];
		$returnpick['name'] = $returnpick['name'];
		$data[] = array(
				'pickuuid' 		=> $returnpick['pickuuid'],
				'creatoruuid' 	=> $returnpick['creatoruuid'],
				'toppick' 		=> $returnpick['toppick'],
				'parceluuid' 	=> $returnpick['parceluuid'],
				'name' 			=> utf8_decode($returnpick['name']),
				'description' 	=> utf8_decode($returnpick['description']),
				'snapshotuuid' 	=> $returnpick['snapshotuuid'],
				'user' 			=> utf8_decode($returnpick['user']),
				'originalname' 	=> utf8_decode($returnpick['originalname']),
				'simname' 		=> utf8_decode($returnpick['simname']),
				'posglobal' 	=> $returnpick['posglobal'],
				'sortorder'		=> $returnpick['sortorder'],
				'enabled' 		=> $returnpick['enabled']);
		$retval = array('success'		=> True,
						'errorMessage'	=> '',
						'data'			=> $data);
		return $retval;
	}

	public function picks_update($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);

		$pickuuid		= $parameter['pick_id'];
		$creator		= $parameter['creator_id'];
		$toppick		= $parameter['top_pick'];
		$parceluuid		= $parameter['parcel_uuid'];
		$name			= $parameter['name'];
		$description	= $parameter['desc'];
		$snapshotuuid	= $parameter['snapshot_id']; 
		$user			= $parameter['user'];
		$original		= $parameter['name'];
		$simname		= $parameter['sim_name'];
		$posglobal		= $parameter['pos_global'];
		$sortorder		= $parameter['sort_order'];
		$enabled		= $parameter['enabled'];

		if ($parceluuid=='')  $parceluuid  = '00000000-0000-0000-0000-0000000000000';
		if ($description=='') $description = JText::_('NO_DESCRIPTION');
		if ($user=='') 		  $user 	   = JText::_('UNKNOWN');
		if ($original=='') 	  $original    = JText::_('UNKNOWN');

		$query = sprintf("INSERT INTO #__opensim_userpicks
													(pickuuid,creatoruuid,toppick,parceluuid,name,description,snapshotuuid,user,originalname,simname,posglobal,sortorder,enabled)
												VALUES
													('%1\$s','%2\$s','%3\$s','%4\$s','%5\$s','%6\$s','%7\$s','%8\$s','%9\$s','%10\$s','%11\$s','%12\$s','%13\$s')
												ON DUPLICATE KEY UPDATE
													creatoruuid		= '%2\$s',
													toppick			= '%3\$s',
													parceluuid		= '%4\$s',
													name			= '%5\$s',
													description		= '%6\$s',
													snapshotuuid	= '%7\$s',
													user			= '%8\$s',
													simname			= '%10\$s',
													posglobal		= '%11\$s',
													sortorder		= '%12\$s',
													enabled			= '%13\$s'",
								mysqlsafestring($pickuuid),
								mysqlsafestring($creator),
								mysqlsafestring($toppick),
								mysqlsafestring($parceluuid),
								mysqlsafestring($name),
								mysqlsafestring(utf8_encode($description)),
								mysqlsafestring($snapshotuuid),
								mysqlsafestring($user),
								mysqlsafestring($original),
								mysqlsafestring($simname),
								mysqlsafestring($posglobal),
								mysqlsafestring($sortorder),
								mysqlsafestring($enabled));
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$result = $db->execute();
		if($result) {
			$retval['success']		= TRUE;
			$retval['errorMessage']	= "";
		} else {
			$retval['success']		= FALSE;
			$retval['errorMessage']	= JText::_('ERROR_UPDATEPICKS');
		}
		return $retval;
	}

	public function picks_delete($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$pickUid	= $parameter['pick_id'];
		$query		= sprintf("DELETE FROM #__opensim_userpicks WHERE pickuuid = '%s'",mysqlsafestring($pickUid));
		$db			= JFactory::getDBO();
		$db->setQuery($query);
		$result		= $db->execute();
		if($result) {
			$retval['success']		= TRUE;
			$retval['errorMessage']	= "";
		} else {
			$retval['success']		= FALSE;
			$retval['errorMessage']	= JText::_('ERROR_UPDATEPICKS');
		}
		return $retval;
	}

	public function avatarclassifiedsrequest($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$classifieds = array();
		$data	= array();
		$db		= JFactory::getDBO();
		$query	= sprintf("SELECT * FROM #__opensim_userclassifieds WHERE creatoruuid = '%s'",mysqlsafestring($parameter['uuid']));
		$db->setQuery($query);
		$classifieds = $db->loadAssocList();
		foreach($classifieds AS $classified) {
			$name = $classified['name'];
			$data[] = array('classifiedid' => $classified['classifieduuid'],
							'name' 	 => $name );
		}
		$retval = array('success'		=> True,
						'errorMessage'	=> '',
						'data'			=> $data);
		return $retval;
	}

	public function classifiedinforequest($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$db		= JFactory::getDBO();
		$query	= sprintf("SELECT * FROM #__opensim_userclassifieds WHERE creatoruuid = '%s' AND classifieduuid = '%s'",
								mysqlsafestring($parameter['avatar_id']),
								mysqlsafestring($parameter['classified_id']));
		$db->setQuery($query);
		$db->execute();
		if($db->getNumRows() > 0) {
			$classified = $db->loadAssocList();
			$returnclassified = $classified[0];
			$returnclassified['description'] = $returnclassified['description'];
			$returnclassified['name']		 = $returnclassified['name'];
			$data[] = array(
					'classifieduuid'	=> $returnclassified['classifieduuid'],
					'creatoruuid' 		=> $returnclassified['creatoruuid'],
					'creationdate'		=> $returnclassified['creationdate'],
					'expirationdate' 	=> $returnclassified['expirationdate'],
					'category' 			=> $returnclassified['category'],
					'name' 				=> $returnclassified['name'],
					'description' 		=> utf8_decode($returnclassified['description']),
					'parceluuid' 		=> $returnclassified['parceluuid'],
					'parentestate' 		=> $returnclassified['parentestate'],
					'snapshotuuid' 		=> $returnclassified['snapshotuuid'],
					'simname' 			=> $returnclassified['simname'],
					'posglobal' 		=> $returnclassified['posglobal'],
					'parcelname' 		=> $returnclassified['parcelname'],
					'classifiedflags' 	=> $returnclassified['classifiedflags'],
					'priceforlisting' 	=> $returnclassified['priceforlisting']);
			$retval = array('success'		=> True,
							'errorMessage'	=> '',
							'data'			=> $data);
		} else {
			$retval = array('success'		=> True,
							'errorMessage'	=> 'Nothing found in function classifiedinforequest for avatar_id '.$parameter['avatar_id']." and classified_id ".$parameter['classified_id'],
							'data'			=> array());
		}
		return $retval;
	}

	public function classified_update($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") {
//			$parameter['testdescription1']	= utf8_encode($parameter['description']);
//			$parameter['testdescription2']	= utf8_decode($parameter['testdescription1']);
//			debugzeile($parameter,"\$parameter for ".__FUNCTION__);
//		}
		$classifieduuid = $parameter['classifiedUUID'];
		$creator		= $parameter['creatorUUID'];
		$category		= $parameter['category'];
		$name			= $parameter['name'];
		$description	= utf8_encode($parameter['description']);
		$parceluuid		= (array_key_exists("parcelUUID",$parameter)) ? $parameter['parcelUUID']:null;
		$parentestate	= $parameter['parentestate'];
		$snapshotuuid	= $parameter['snapshotUUID'];
		$simname		= $parameter['sim_name'];
		$globalpos		= $parameter['globalpos'];
		$parcelname		= (array_key_exists("parcelname",$parameter)) ? $parameter['parcelname']:null;
		$classifiedflag = $parameter['classifiedFlags'];
		$priceforlist	= $parameter['classifiedPrice'];

		if ($parcelname=='')  $parcelname  = JText::_('UNKNOWN');
		if ($parceluuid=='')  $parceluuid  = '00000000-0000-0000-0000-0000000000000';
		if ($description=='') $description = JText::_('NO_DESCRIPTION');

		$creationdate   = time();
		$settings = jOpenSimSettings();

		if($settings['classified_hide'] == -1) { //hide never
			$expirationdate = 4294967295; // this is the max positive integer value that DB field can take
	//		$expirationdate = 2147483647; // this is the max positive integer value that DB field can take
		} else {
			$expirationdate = time() + $settings['classified_hide'];
		}

		$query = sprintf("INSERT INTO #__opensim_userclassifieds
												(classifieduuid,creatoruuid,creationdate,expirationdate,category,name,description,parceluuid,parentestate,snapshotuuid,simname,posglobal,parcelname,classifiedflags,priceforlisting)
											VALUES
												('%1\$s','%2\$s','%3\$d','%4\$d','%5\$s','%6\$s','%7\$s','%8\$s','%9\$d','%10\$s','%11\$s','%12\$s','%13\$s','%14\$d','%15\$d')
											ON DUPLICATE KEY UPDATE
												creatoruuid		= '%2\$s',
											#	creationdate	= '%3\$d',
											#	expirationdate	= '%4\$d',
												category		= '%5\$s',
												name			= '%6\$s',
												description		= '%7\$s',
												parceluuid		= '%8\$s',
												parentestate	= '%9\$d',
												snapshotuuid	= '%10\$s',
												simname			= '%11\$s',
												posglobal		= '%12\$s',
												parcelname		= '%13\$s',
												classifiedflags	= '%14\$d',
												priceforlisting	= '%15\$d'",
								mysqlsafestring($classifieduuid),
								mysqlsafestring($creator),
								mysqlsafestring($creationdate),
								mysqlsafestring($expirationdate),
								mysqlsafestring($category),
								mysqlsafestring($name),
								mysqlsafestring($description),
								mysqlsafestring($parceluuid),
								mysqlsafestring($parentestate),
								mysqlsafestring($snapshotuuid),
								mysqlsafestring($simname),
								mysqlsafestring($globalpos),
								mysqlsafestring($parcelname),
								mysqlsafestring($classifiedflag),
								mysqlsafestring($priceforlist));
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$result = $db->execute();
		if($result) {
			$retval['success']		= TRUE;
			$retval['errorMessage']	= "";
		} else {
			$retval['success']		= FALSE;
			$retval['errorMessage']	= JText::_('ERROR_UPDATECLASSIFIED');
		}
		return $retval;
	}

	public function classified_delete($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		$classifiedID = $parameter['classifiedID'];
		$query = sprintf("DELETE FROM #__opensim_userclassifieds WHERE classifieduuid = '%s'",mysqlsafestring($classifiedID));
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$result = $db->execute();
		if($result) {
			$retval['success']		= TRUE;
			$retval['errorMessage']	= "";
		} else {
			$retval['success']		= FALSE;
			$retval['errorMessage']	= JText::_('ERROR_UPDATECLASSIFIED');
		}
		return $retval;
	}

	public function clientInfo($parameter) {
//		global $debug;
//		if(is_array($debug) && array_key_exists("profile",$debug) && $debug['profile'] == "1") debugzeile($parameter,"\$parameter for ".__FUNCTION__);
		if(!array_key_exists("agentName",$parameter) && !array_key_exists("agentIP",$parameter) && !array_key_exists("agentID",$parameter)) return; // no params, what should we save?
		$agent	= (array_key_exists("agentName",$parameter)) ? $parameter['agentName']:"unknown";
		$userip	= (array_key_exists("agentIP",$parameter)) ? $parameter['agentIP']:"127.0.0.3";
		$uuid	= (array_key_exists("agentID",$parameter)) ? $parameter['agentID']:"00000000-0000-0000-0000-000000000000";
		if(strstr($agent,"@") !== FALSE) {
			$lastpos	= strlen($agent) - strlen(strrchr($agent,"@"));
			$hoststring	= "http://".substr(strrchr($agent,"@"),1);
			$hostarray	= parse_url($hoststring);
			if(array_key_exists("host",$hostarray) && $hostarray['host']) {
				// den Hostnamen aus URL holen
				preg_match('@^(?:http://)?([^/]+)@i',$hostarray['host'], $treffer);
				$host = $treffer[1];
				// die letzten beiden Segmente aus Hostnamen holen
				preg_match('/[^.]+\.[^.]+$/', $host, $treffer);
				if(is_array($treffer) && count($treffer) > 0 && $treffer[0]) {
					$username	= substr($agent,0,$lastpos);
					$host		= $hostarray['host'];
				} else {
					$username	= $agent;
					$host		= "local";
				}
			} else {
				$username	= $agent;
				$host		= "local";
			}
		} else {
			$username	= $agent;
			$host		= "local";
		}
		$query = sprintf("INSERT INTO #__opensim_clientinfo (PrincipalID,userName,grid,remoteip,lastseen,`from`) VALUES ('%1\$s','%2\$s','%3\$s','%4\$s',NOW(),'P')
							ON DUPLICATE KEY UPDATE userName = '%2\$s', grid = '%3\$s', remoteip = '%4\$s', lastseen = NOW(), `from`= 'P'",
			$uuid,
			mysqlsafestring(trim($username)),
			$host,
			$userip);
		$db = JFactory::getDBO();
		$db->setQuery($query);
		$db->execute();
	}

	public function initMethods() {
		$this->xmlrpcfunctions['searchfunctions'] = array(
				"init_SearchDataUpdate",
				"searchDataUpdate",
				"dir_places_query",
				"dir_popular_query",
				"dir_land_query",
				"dir_events_query",
				"dir_classified_query",
				"event_info_query",
				"classifieds_info_query"); // all methods for handling inworld search
		$this->xmlrpcfunctions['profilefunctions'] = array(
				"avatar_properties_request",
				"avatar_properties_update",
				"avatar_interests_update",
				"avatarnotesrequest",
				"avatar_notes_update",
				"avatarpicksrequest",
				"pickinforequest",
				"picks_update",
				"picks_delete",
				"avatarclassifiedsrequest",
				"classifiedinforequest",
				"classified_update",
				"classified_delete",
				"user_preferences_request",
				"user_preferences_update",
				"clientInfo"); // all methods for the profile handling
		$this->xmlrpcfunctions['groupfunctions'] = array(
				"groups.createGroup",
				"groups.updateGroup",
				"groups.getGroup",
				"groups.findGroups",
				"groups.getGroupRoles",
				"groups.addRoleToGroup",
				"groups.removeRoleFromGroup",
				"groups.updateGroupRole",
				"groups.getGroupRoleMembers",
				"groups.setAgentGroupSelectedRole",
				"groups.addAgentToGroupRole",
				"groups.removeAgentFromGroupRole",
				"groups.getGroupMembers",
				"groups.addAgentToGroup",
				"groups.removeAgentFromGroup",
				"groups.setAgentGroupInfo",
				"groups.addAgentToGroupInvite",
				"groups.getAgentToGroupInvite",
				"groups.removeAgentToGroupInvite",
				"groups.setAgentActiveGroup",
				"groups.getAgentGroupMembership",
				"groups.getAgentGroupMemberships",
				"groups.getAgentActiveMembership",
				"groups.getAgentRoles",
				"groups.getGroupNotices",
				"groups.getGroupNotice",
				"groups.addGroupNotice"); // all (?) methods for group handling	}
	}

	public function setDebug() {
		$this->debug['access']		= $this->settings['jopensim_debug_access'];
		$this->debug['input']		= $this->settings['jopensim_debug_input'];
		$this->debug['profile']		= $this->settings['jopensim_debug_profile'];
		$this->debug['groups']		= $this->settings['jopensim_debug_groups'];
		$this->debug['search']		= $this->settings['jopensim_debug_search'];
		$this->debug['messages']	= $this->settings['jopensim_debug_messages'];
		$this->debug['currency']	= $this->settings['jopensim_debug_currency'];
		$this->debug['terminal']	= $this->settings['jopensim_debug_terminal'];
		$this->debug['other']		= $this->settings['jopensim_debug_other'];
		$this->debug['path']		= $this->settings['jopensim_debug_path'];
	}

// ###############################################
// ########## offline message functions ##########
// ###############################################

	public function saveMessage($data) {
		error_log("here I am ;) (Zeile ".__LINE__.")");
		$functionblock = "Offline Messages";
		$retval = "";
		$debug = var_export($this->settings,TRUE);
//		error_log("Settings: ".$debug." (Zeile ".__LINE__.")");
		if($this->debug['messages'] == "1") $this->simpledebugzeile("[SaveMessage] fired from ".$data['remoteip']." at line ".__LINE__." in ".__FILE__,$functionblock);
		if($this->settings['addons_messages'] == 0) {
			if($this->debug['messages'] == "1") $this->simpledebugzeile("Offline Messages disabled!",$functionblock);
			return "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><boolean>false</boolean>";
		}
		$message = $this->opensim->parseOSxml($data['input']);
		error_log("here I am ;) (Zeile ".__LINE__.")");
		if($this->debug['messages'] == "1") $this->debugzeile($message,"message",$functionblock);
		$searchstr = "?".">";
		$start = strpos($data['input'], $searchstr);
		if($this->debug['messages'] == "1") $this->simpledebugzeile("\nstart:\n".$start,$functionblock);
		error_log("here I am ;) (Zeile ".__LINE__.")");
		if ($start != -1) {
			$start+=2;
			$msg = substr($data['input'], $start);
			if($this->debug['messages'] == "1") $this->simpledebugzeile("\nmsg:\n".$msg,$functionblock);
			try {
				$db = JFactory::getDBO();
				$query = sprintf("INSERT INTO #__opensim_offlinemessages (imSessionID,fromAgentID,fromAgentName,toAgentID,fromGroup,message,remoteip,sent) VALUES ('%s','%s','%s','%s','%s','%s','%s',NOW())",
						$message['imSessionID'],
						$message['fromAgentID'],
						$message['fromAgentName'],
						$message['toAgentID'],
						$message['fromGroup'],
						addslashes($msg),
						$data['remoteip']);
				$db->setQuery($query);
				$db->execute();
				$retval = "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><boolean>true</boolean>";

				// no need to check in components settings for offline messages since we would not be here if disabled
				$usersettings = $this->opensim->getUserSettings($message['toAgentID']);
				if($usersettings['im2email'] == 1) { // Send Email to "toAgentID" only if set in user settings
					$config		= JFactory::getConfig();
					if($message['fromGroup'] == "true") {
						$groupname	= getGroupName($message['fromAgentID']);
						$subject	= JText::sprintf(JOPENSIM_GROUPIM2MAILSUBJECT,$groupname,$config->get('fromname'))." (".$message['fromAgentName'].")";
						$dash		= strpos($message['message'],"|");
						if($dash) {
							$message['message'] = JText::_('JOPENSIM_GROUPNOTICE_SUBJECT').str_replace("|","\n\n",substr($message['message'],0,($dash+1))).substr($message['message'],($dash+1));
						}
					} else {
						$subject	= JText::_('IM2MAILSUBJECT')." ".$config->get('fromname')." (".$message['fromAgentName'].")";
					}
					$userdata	= $this->opensim->getUserData($message['toAgentID']);
					$mailer		= JFactory::getMailer();
					$sender		= array($config->get('mailfrom'),$config->get('fromname'));
					$body		= JText::_('IMFROM').": ".$message['fromAgentName']."\n\n".$message['message'];
					$mailer->setSender($sender);
					$mailer->addRecipient($userdata['email']);
					$mailer->setSubject($subject);
					$mailer->setBody($body);
					$mailer->Send();
				}
			} catch (Exception $e) {
				$errormsg = $e->getMessage();
				if($this->debug['messages'] == "1") $this->simpledebugzeile("error: ".$errormsg,$functionblock);
				$retval = "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><boolean>false</boolean>";
			}
		} else {
			if($this->debug['messages'] == "1") $this->simpledebugzeile("\nno message found in request",$functionblock);
			$retval = "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><boolean>false</boolean>";
		}
		error_log("here I am ;) (Zeile ".__LINE__.")");
		if($this->debug['messages'] == "1") $this->debugzeile("Response for saveMessage:\n\n".$retval,$functionblock);
		return $retval;
	}

	public function retrieveMessages($data) {
		$functionblock = "Offline Messages";
		if($this->debug['messages'] == "1") $this->simpledebugzeile("Offline Messages [RetrieveMessages] fired from ".$data['remoteip']." at line ".__LINE__." in ".__FILE__,$functionblock);

		$message	= $this->opensim->parseOSxml($data['input']);
		$guid		= $message['Guid'];
		$db			= JFactory::getDBO();
		$query		= sprintf("SELECT message FROM #__opensim_offlinemessages WHERE toAgentID = '%s' ORDER BY sent",
				$guid);
		$db->setQuery($query);
		$messages	= $db->loadRowList();
		$retval		= "<?x"."ml version=\"1.0\" encoding=\"utf-8\"?><ArrayOfGridInstantMessage xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">";
		foreach($messages AS $message) {
			$retval .= $message[0];
		}
		$retval .= "</ArrayOfGridInstantMessage>";
		$query = sprintf("DELETE FROM #__opensim_offlinemessages WHERE toAgentID = '%s'",$guid);
		$db->setQuery($query);
		$db->execute();
		if($this->debug['messages'] == "1") $this->debugzeile("Response for retrieveMessages:\n\n".$retval,$functionblock);
		return $retval;
	}

// ########################################
// ########## terminal functions ##########
// ########################################

	public function terminal_identify($data) {
		$functionblock = "terminal";
		if($this->settings['addons_inworldauth'] == 0) {
			if($this->debug['terminal'] == "1") $this->simpledebugzeile("Terminal identify (but disabled in config) fired from ".$data['remoteip']." at line ".__LINE__." in ".__FILE__,$functionblock);
			exit; // nothing to do if the addon is disabled
		} else {
			if($this->debug['terminal'] == "1") $this->simpledebugzeile("Terminal identify fired from ".$data['remoteip']." at line ".__LINE__." in ".__FILE__,$functionblock);
		}
		$db = JFactory::getDBO();
		// first clean up old ident requests
		if($this->settings['addons_identminutes'] > 0) {
			$query = sprintf("DELETE FROM #__opensim_inworldident WHERE created < DATE_SUB(NOW(), INTERVAL %d MINUTE)",$this->settings['addons_identminutes']);
			$db->setQuery($query);
			$db->execute();
		}
		// first check if uuid has already a joomla relation
		$query = sprintf("SELECT joomlaID FROM #__opensim_userrelation WHERE opensimID = '%s'",$data['identKey']);
		$db->setQuery($query);
		$db->execute();
		$num_rows = $db->getNumRows();
		if($num_rows > 0) {
			$retval = JText::_('INWORLDALREADYIDENTIFIED');
		} else {
			// no relation existing, check if some inworld ident is prepared
			$query = sprintf("SELECT joomlaID FROM #__opensim_inworldident WHERE inworldIdent = '%s'",$data['identString']);
			$db->setQuery($query);
			$db->execute();
			$num_rows = $db->getNumRows();
			if($num_rows > 0) {
				$joomlaId = $db->loadResult();
				// this should actually never happen, but better check this as well:
				$query = sprintf("SELECT opensimID FROM #__opensim_userrelation WHERE joomlaID = '%d'",$joomlaId);
				$db->setQuery($query);
				$db->execute();
				$num_rows = $db->getNumRows();
				if($num_rows > 0) { // something went completely wrong here, hope this causes ppl to report a bug
					$retval = "Error while double check joomlaID ".$joomlaId." (could be a bug)! Please contact the Gridmanager and/or FoTo50 at the support forum at http://www.jopensim.com";
				} else { // Everything ok, inworld account identified
					// Update the relation table
					$query = sprintf("INSERT INTO #__opensim_userrelation (joomlaID,opensimID) VALUES ('%1\$d','%2\$s')",$joomlaId,$data['identKey']);
					$db->setQuery($query);
					$db->execute();
					// and delete from the ident table
					$query = sprintf("DELETE FROM #__opensim_inworldident WHERE inworldIdent = '%s'",$data['identString']);
					$db->setQuery($query);
					$db->execute();
					$retval = JText::_('IDENTIFYINWORLDSUCCESS');
				}
			} else { // no inworld ident found, give a proper message
				$retval = JText::_('IDENTIFYINWORLDFAILED');
			}
		}
		if($this->debug['terminal'] == "1") $this->debugzeile("Response for ".__FUNCTION__.":\n\n".$retval,$functionblock);
		return $retval;
	}

	public function terminal_register($remoteip) {
		$functionblock = "terminal";
		if($this->settings['addons_inworldauth'] == 0) {
			if($this->debug['terminal'] == "1") $this->simpledebugzeile("Terminal register (but disabled in config) fired from ".$remoteip." at line ".__LINE__." in ".__FILE__,$functionblock);
			return JText::_('IDENTIFYINWORLDDISABLED');
		} else {
			if($this->debug['terminal'] == "1") $this->simpledebugzeile("Terminal register fired from ".$remoteip." at line ".__LINE__." in ".__FILE__,$functionblock);
		}
		$terminalDescription	= JFactory::getApplication()->input->get('terminalDescription','','string');
		$terminalUrl			= JFactory::getApplication()->input->get('myurl','','raw');
		$regionString			= $_SERVER['HTTP_X_SECONDLIFE_REGION'];
		$locationString			= $_SERVER['HTTP_X_SECONDLIFE_LOCAL_POSITION'];
		$terminalKey			= $_SERVER['HTTP_X_SECONDLIFE_OBJECT_KEY'];
		$terminalName			= $_SERVER['HTTP_X_SECONDLIFE_OBJECT_NAME'];
		$region_suchmuster		= "/([^\(])*/";
		preg_match($region_suchmuster,$regionString,$treffer);
		$region = trim($treffer[0]);
		$location_suchmuster	= "/[^\d]*([\d\.]*)[^\d]*([\d\.]*)[^\d]*([\d\.]*)/";
		preg_match_all($location_suchmuster,$locationString,$treffer,PREG_SET_ORDER);
		$location_x = $this->roundoff($treffer[0][1],0);
		$location_y = $this->roundoff($treffer[0][2],0);
		$location_z = $this->roundoff($treffer[0][3],0);
		$db = JFactory::getDBO();
		$query = sprintf("SELECT staticLocation FROM #__opensim_terminals WHERE terminalKey = '%s'",$terminalKey);
		$db->setQuery($query);
		$db->execute();
		$num_rows = $db->getNumRows();
		if($num_rows > 0) {
			$terminalstatic = $db->loadResult();
			if($terminalstatic == "1") {
				$retval = "Terminal found, but not updated due to static setting!";
			} else {
				$query = sprintf("UPDATE #__opensim_terminals SET
									terminalName = '%s',
									terminalDescription = '%s',
									terminalUrl = '%s',
									region = '%s',
									location_x = '%d',
									location_y = '%d',
									location_z = '%d'
								WHERE
									terminalKey = '%s'",
					$terminalName,
					$terminalDescription,
					$terminalUrl,
					$region,
					$location_x,
					$location_y,
					$location_z,
					$terminalKey);
				$db->setQuery($query);
				$db->execute();
				$retval = "Terminal found and sucessfully updated!";
			}
		} else {
			$query = sprintf("INSERT INTO #__opensim_terminals
									(terminalName,terminalDescription,terminalKey,terminalUrl,region,location_x,location_y,location_z)
								VALUES
									('%s','%s','%s','%s','%s','%d','%d','%d')",
					$terminalName,
					$terminalDescription,
					$terminalKey,
					$terminalUrl,
					$region,
					$location_x,
					$location_y,
					$location_z);
			$db->setQuery($query);
			$db->execute();
			$retval = "Terminal sucessfully registered!";
		}
		if($this->debug['terminal'] == "1") $this->debugzeile("Response for ".__FUNCTION__.":\n\n".$retval,$functionblock);
		return $retval;
	}

	public function terminal_setState($remoteip) {
		$functionblock = "terminal";
		if($this->debug['terminal'] == "1") $this->simpledebugzeile("Terminal setState fired from ".$remoteip." at line ".__LINE__." in ".__FILE__,$functionblock);
		$terminalState	= JFactory::getApplication()->input->get('state');
		$terminalKey	= $_SERVER['HTTP_X_SECONDLIFE_OBJECT_KEY'];
		$query			= sprintf("UPDATE #__opensim_terminals SET active = '%d' WHERE terminalKey = '%s'",$terminalState,$terminalKey);
		$db				= JFactory::getDBO();
		$db->setQuery($query);
		$db->execute();
		if($terminalState == 1) $retval = JText::_('TERMINALSETVISIBLE');
		else $retval = JText::_('TERMINALSETINVISIBLE');
		if($this->debug['terminal'] == "1") $this->debugzeile("Response for ".__FUNCTION__.":\n\n".$retval,$functionblock);
		return $retval;
	}

// #####################################
// ########## debug functions ##########
// #####################################

	public function simpledebugzeile($zeile,$functionblock = "") {
//		error_log("here I am ;) (Zeile ".__LINE__.")");
		$zeit = date("Y-m-d H:i:s");
		$logfile = $this->debug['path']."interface.log";
		$handle = fopen($logfile,"a+");
		$logzeile = $zeit."\t".$zeile."\n";
		fputs($handle,$logzeile);
		fclose($handle);
	}

	public function debugzeile($zeile,$function = "",$functionblock = "") {
		if(!$function) $zeit = "\n\n########## ".date("d.m.Y H:i:s")." ##########\n";
		else $zeit = "\n\n########## ".date("d.m.Y H:i:s")." ##### ".$function." ##########\n";
		$zeile = var_export($zeile,TRUE);
		$logfile = $this->debug['path']."interface.log";
		$handle = fopen($logfile,"a+");
		$logzeile = $zeit.$zeile."\n\n";
		fputs($handle,$logzeile);
		fclose($handle);
	}

	public function roundoff($v, $d) {
		$r = pow(10, $d);
		$v *= $r;
		if ($v - floor($v) >= 0.5) {
			return(ceil($v)/$r);
		} else {
			return (floor($v)/$r);
		}
	}
}
?>
