<?php
/*
 * @component jOpenSim
 * @copyright Copyright (C) 2019 FoTo50 http://www.jopensim.com/
 * @license GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');


class opensimViewinterface extends JViewLegacy {

	public function display($tpl = null) {
		error_log("here I am ;) (Zeile ".__LINE__." in ".__FILE__.")");
		$model	= $this->getModel();

		$this->input = file_get_contents("php://input");
		$this->xmlrpcfunctions = $model->xmlrpcfunctions;

		$profilefunctions	= $this->xmlrpcfunctions['profilefunctions'];
		$groupfunctions		= $this->xmlrpcfunctions['groupfunctions'];
		$searchfunctions	= $this->xmlrpcfunctions['searchfunctions'];

		$jinput	= JFactory::getApplication()->input;
		$this->test = $test	= $jinput->get('test',null,'STR');

		if($test) { // this is testing mode for output in html
			$this->retval = "";
			if(in_array($test,$profilefunctions)) {
				$this->functionblock = "profile";
				$params = $_REQUEST;
				unset($params['test']);
				$this->retval = $model->$test($params);
			} elseif(in_array($test,$groupfunctions)) {
				$this->functionblock = "groups";
				$params = $_REQUEST;
				unset($params['test']);
//				$function	= substr($method,7); // remove "groups." from method name
				$this->retval = $model->$test($params);
			} elseif(in_array($test,$searchfunctions)) {
				$this->functionblock = "search";
				$params = $_REQUEST;
				unset($params['test']);
				$this->retval = $model->$test($params);
			} else {
				$this->functionblock = "functionblock not found :(<br />";
			}
			$this->debug_settings = $model->settings;
			parent::display($tpl);

		} else { // a "real" xmlrpc request, dont output in html, but return valid xml response
			$remoteip	= $_SERVER['REMOTE_ADDR']; // who is talking with us?

			// ##############################
			// ##### handling terminals #####
			// ##############################

			$action		= $jinput->get('action',null,'STR');
			switch($action) { // here we most probably receive some request from a terminal
				case "identify":
					$data['remoteip']		= $remoteip;
					$data['identString']	= $jinput->get('identString',null,'STR');
					$data['identKey']		= $jinput->get('identKey',null,'STR');
					$response				= $model->terminal_identify($data);
					echo $response;
					exit; // we have done already everything, dont check if there could be more
				break;
				case "register":
					$response				= $model->terminal_register($remoteip);
					echo $response;
					exit; // we have done already everything, dont check if there could be more
				break;
				case "setState":
					$response				= $model->terminal_setState($remoteip);
					echo $response;
					exit; // we have done already everything, dont check if there could be more
				break;
			}


			// #####################################
			// ##### handling offline messages #####
			// #####################################

			$messaging = $jinput->get('messaging',null,'raw');
			switch($messaging) { // with view system offline messages need to be handled different >:(
				case "/SaveMessage/":
					$data['input']		= $this->input;
					$data['remoteip']	= $remoteip;
					$retval				= $model->saveMessage($data);
					echo $retval;
					exit;
				break;
				case "/RetrieveMessages/":
					$data['input']		= $this->input;
					$data['remoteip']	= $remoteip;
					$retval				= $model->retrieveMessages($data);
					echo $retval;
					exit;
				break;
			}

			// todo: here the $opensim->checkRegionIP() to implement
			// todo: as well as the new support key system


			$request	= $model->opensim->parseXmlRpc($this->input);
			$method		= $request['method'];
			$params		= $request['decode'][0];

			if(in_array($method,$profilefunctions) || in_array($method,$groupfunctions) || in_array($method,$searchfunctions)) {
				if(method_exists($model,$method) {
					$this->retval = $model->$method($params);
				} else {
					$this->retval	= array('success'		=> False,
											'errorMessage'	=> 'Error handling method '.$method,
											'data'			=> array());
				}
				$response = xmlrpc_encode($this->retval);
				echo $response;
				exit; // no further output ... stop here
			}
		}


		

	}
}
?>